



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>vue 响应式原理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">vue 响应式原理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-23 07:20:25 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Vue 采用声明式编程替代过去的类 Jquery 的命令式编程，并且能够侦测数据的变化，更新视图。这使得我们可以只关注数据本身，而不用手动处理数据到视图的渲染，避免了繁琐的 DOM 操作，提高了开发效率。不过理解其工作原理同样重要，这样可以回避一些常见的问题，下面我们来介绍一下 Vue 是如何侦测数据并响应视图的。</p>
<h3>Object.defineProperty</h3>
<p>Vue 数据响应核心就是使用了&nbsp;<code>Object.defineProperty&nbsp;</code>方法（ IE9 + ) 。</p>
<div>
<pre class="prettyprint linenums">var obj = {};<br />
Object.defineProperty(obj, 'msg', {<br />
  get () {<br />
    console.log('get');<br />
  },<br />
  set (newVal) {<br />
    console.log('set', newVal);<br />
  }<br />
});<br />
obj.msg // get<br />
obj.msg = 'hello world' // set hello world</pre>
</div>
<p>取 obj 对象中 msg 的值时会调用 get 方法，给 msg 赋值时会调用 set 方法，并接收新值作为其参数。</p>
<p>这里提一句，在 Vue 中我们调用数据是直接 this.xxx ，而数据其实是 this.data.xxx，原来 Vue 在初始化数据的时候会遍历 data 并代理这些数据。</p>
<div>
<pre class="prettyprint linenums">Object.keys(this.data).forEach((key) =&gt; {<br />
    this.proxyKeys(key);<br />
});

proxyKeys (key) {<br />
    Object.defineProperty(this, key, {<br />
        enumerable: false,<br />
        configurable: true,<br />
        get() {<br />
            return this.data[key];<br />
        },<br />
        set(newVal) {<br />
            this.data[key] = newVal;<br />
        }<br />
    });<br />
}</pre>
</div>
<p>上面可以看到，取 this.key 的值其实是取 this.data.key 的值，赋值同理。</p>
<p>现在，我们已经知道如何去检测数据的变化，并且做出一些响应了。</p>
<h3>观察者模式 ( 发布者-订阅者模式 )</h3>
<p>vue 的响应式系统依赖于三个重要的类：Dep 类、Watcher 类、Observer 类。</p>
<p>Dep 类作为发布者的角色，Watcher 类作为订阅者的角色，Observer 类则是连接发布者和订阅者的纽带，决定订阅和发布的时机。</p>
<p>我们先看下面的代码，来对发布者和订阅者有个初步的了解。</p>
<div>
<pre class="prettyprint linenums">class Dep {<br />
    constructor() {<br />
        this.subs = [];<br />
    }

    addSub(watcher) {<br />
        this.subs.push(watcher);<br />
    }

    notify() {<br />
        this.subs.forEach(watcher =&gt; {<br />
            watcher.update();<br />
        });<br />
    }<br />
}

class Watcher {<br />
    constructor() {<br />
    }

    update() {<br />
        // 接收通知后的处理方法<br />
    }<br />
}

const dep = new Dep(); // 发布者 dep<br />
const watcher1 = new Watcher(); // 订阅者1 watcher1<br />
const watcher2 = new Watcher(); // 订阅者2 watcher2<br />
dep.addSub(watcher1); // watcher1 订阅 dep<br />
dep.addSub(watcher2); // watcher2 订阅 dep<br />
dep.notify(); // dep 发送通知</pre>
</div>
<p>上面我们定义了一个发布者 dep，两个订阅者 watcher1、watcher2。让&nbsp;watcher1、watcher2 都订阅 dep，当 dep 发送通知时，watcher1、watcher2 都能做出各自的响应。</p>
<p>现在我们已经了解了发布者和订阅者的关系，那么剩下的就是订阅和发布的时机。什么时候订阅？什么时候发布？想到上面提到的 Object.defineProperty ，想必你已经有了答案。</p>
<p>我们来看 Observer 类的实现：</p>
<div>
<pre class="prettyprint linenums">class Observer {<br />
    constructor(data) {<br />
        this.data = data;<br />
        this.walk();<br />
    }

    walk() {<br />
        Object.keys(this.data).forEach(key =&gt; {<br />
            this.defineReactive(this.data, key, this.data[key]);<br />
        });<br />
    }

    defineReactive(data, key, value) {<br />
        const dep = new Dep();

        if ( value &amp;&amp; typeof value === 'object' ) {<br />
            new Observer(value);<br />
        }

        Object.defineProperty(data, key, {<br />
            enumerable: true,<br />
            configurable: true,<br />
            get() {<br />
                if (Dep.target) {<br />
                    dep.addSub(Dep.target); // 订阅者订阅 Dep.target 即当前 Watcher 类的实例（订阅者）<br />
                }<br />
                return value;<br />
            },<br />
            set(newVal) {<br />
                if (newVal === value) {<br />
                    return false;<br />
                }<br />
                value = newVal;<br />
                dep.notify(); // 发布者发送通知<br />
            }<br />
        });<br />
    }<br />
}</pre>
</div>
<p>在&nbsp;Observer 类中，为 data 的每个属性都实例化一个 Dep 类，即发布者。并且在取值时让订阅者（有多个，因为 data 中的每个属性都可以被应用在多个地方）订阅，在赋值时发布者发布通知，让订阅者做出各自的响应。</p>
<p>这里需要提的是 Dep.target，这其实是 Watcher 类的实例，我们可以看看&nbsp;Watcher 的详细代码：</p>
<div>
<pre class="prettyprint linenums">class Watcher {<br />
    constructor(vm, exp, cb) {<br />
        this.vm = vm;<br />
        this.exp = exp; // data 属性名<br />
        this.cb = cb; // 回调函数

        // 将自己添加到订阅器<br />
        this.value = this.getValue();<br />
    }

    update() {<br />
        const value = this.vm.data[this.exp];<br />
        const oldValue = this.value;<br />
        if (value !== oldValue) {<br />
            this.value = value;<br />
            this.cb.call(this.vm, value, oldValue); // 执行回调函数<br />
        }<br />
    }

    getValue() {<br />
        Dep.target = this; // 将自己赋值给 Dep.target<br />
        const value = this.vm.data[this.exp]; // 取值操作触发订阅者订阅<br />
        Dep.target = null;<br />
        return value;<br />
    }<br />
}</pre>
</div>
<p>Watcher 类在构造函数中执行了一个 getValue 方法，将自己赋值给 Dep.target ，并且执行了取值操作，这样就成功的完成了订阅操作。一旦数据发生变化，即有了赋值操作，发布者就会发送通知，订阅者就会执行自己的 update 方法来响应这次数据变化。</p>
<h3>数据的双向绑定</h3>
<p>数据的双向绑定即数据和视图之间的同步，视图随着数据变化而变化，反之亦然。我们知道 Vue 是支持数据的双向绑定的，主要应用于表单，是通过 v-model 指令来实现的。而通过上面介绍的知识我们是可以知道如何实现视图随着数据变化的，那么如何让数据也随着视图变化而变化呢？其实也很简单，只要给有 v-model 指令的节点监听相应的事件即可，在事件回调中来改变相应的数据。这一切都 Compile 类中完成，假设有一个 input 标签应用了 v-model 指令，在开始编译模板时，遇到 v-model 指令时会执行：更新 dom 节点的值，订阅者订阅，事件监听。</p>
<div>
<pre class="prettyprint linenums">compileModel (node, vm, exp) {<br />
    let val = vm[exp];

    // 更新内容<br />
    this.modelUpdater(node, val);

    // 添加订阅<br />
    new Watcher(vm, exp, (value) =&gt; {<br />
        // 数据改变时的回调函数<br />
        this.modelUpdater(node, value);<br />
    });

    // 事件监听<br />
    node.addEventListener('input', (e) =&gt; {<br />
        const newValue = e.target.value;<br />
        if (val === newValue) {<br />
            return false;<br />
        }<br />
        vm[exp] = newValue;<br />
        val = newValue;<br />
    });<br />
}</pre>
</div>
<p>当我们在文本框中输入数据时，会给原有 data 中的某个属性 a 赋值，这时候会触发发布者发起通知，那么所有属性 a 的订阅者都能够同步到最新的数据。</p>
<p>最后，附上一个小 <a href="http://jsfiddle.net/ao5rcnny/8/?utm_source=website&amp;utm_medium=embed&amp;utm_campaign=ao5rcnny" rel="external nofollow noreferrer">demo</a></p>
<p><img referrerpolicy="no-referrer"src="https://img2020.cnblogs.com/blog/752429/202003/752429-20200318223812526-1453422944.jpg" /></p>
<div>
<p>更多精彩内容，欢迎关注微信公众号~</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwdkdl8.html">灵活的JavaScript（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9672nv8.html">WebApi身份认证解决方案：Basic基础认证</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx3p5vq.html">JQuery学习&lpar;选择器-基本-&ast;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zw5wd8.html">Ladda &ndash; 把加载提示效果集成到按钮中，提升用户体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmk6o09.html">string&period;length&lpar;&rpar;与-1比较为什么会出现匪夷所思的结果</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v5n1o8.html">linux与Windows共享文件配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x4vor9.html">HDOJ&lpar;HDU&rpar; 1898 Sempr &equals;&equals; The Best Problem Solver&quest;&lpar;水题、、、&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjlwg49.html">BNU10791：DOTA选人</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yyokz8.html">cocos2d-x物业现场</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojervpq.html">几道c&sol;c&plus;&plus;练习题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgxenm8.html">对半导体制造&lpar;FAB&rpar;工种的全方位解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megjjrq.html">opensetting禁用后小程序二次授权的问题-以及根据定位城市获取天气</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2272o9.html">小程序入口构造工具&amp;amp&semi;二维码测试工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/960w2zj9.html">&fjlig;wc2019 D4T1 循环流</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4z4dz9.html">Intellij IDEA神器值得收藏的小技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4kr7lq.html">CI框架中集成CKEditor编辑器的教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pp560q.html">Java如何查看线程的优先级？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnp36rq.html">Visual Studio 2013 离线版msdn下载和安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/95pxom6q.html">java类继承总结一 父类类型与子类类型之间的转化问题&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44kkx5q.html">本地连不上远程mysql数据库&lpar;2&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4z7lk09.html">关于SSH</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo6dv1q.html">Relocation    状态压缩DP</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z7r459.html">hud   2577    How to Type</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk6pvv8.html">cs224d 自然语言处理作业 problem set3 &lpar;一&rpar; 实现Recursive Nerual Net Work 递归神经网络</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpkwv79.html">jQuery经典案例</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kyed29.html">Quartz入门案例与介绍（与spring整合）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gezl2z8.html">oracle排序的几种方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kprp269.html">Arrays&period;asList &lpar;&rpar; 不可添加或删除元素的原因</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mkm1m8.html">【转载】基于VoiceOver的移动web站无障碍访问实战</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojljelq.html">笨鸟先飞之ASP&period;NET MVC系列之过滤器&lpar;04认证过滤器过滤器&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
